---
- name: "Configuration (cache mode) | temporary directory to hold configuration"
  become: no
  delegate_to: localhost
  command: mktemp -d
  register: slurm_tmpwrk
  check_mode: no
  when: slurm_tmpwrk is undefined
  run_once: yes

#looped over all cluster hosts so that every host has the info
- name: "Configuration (cache mode) | save temporary directory once and for all"
  set_fact:
    slurm_tmp_wrkdir: "{{ slurm_tmpwrk.stdout }}"
  check_mode: no
  run_once: yes
  delegate_to: "{{ item }}"
  with_items: "{{ slurm_current_clusters_all_hosts }}"
  delegate_facts: yes
  when: slurm_tmpwrk.stdout is defined

- name: "Configuration (cache mode) | check if configuration has already been generated"
  stat:
      path: "{{ slurm_tmp_wrkdir }}/slurm.conf"
  delegate_to: localhost
  become: no
  run_once: yes
  check_mode: no
  register: conf_generated

- name: "Configuration (cache mode) | Generate slurm configuration on ansible executor"
  become: no
  template:
    src: "{{ item }}"
    dest: "{{ slurm_tmp_wrkdir }}/slurm.conf"
  with_first_found:
    - "{{ playbook_dir }}/templates/{{ slurm_cluster_name }}/slurm.conf.j2"
    - "{{ playbook_dir }}/templates/slurm.conf.j2"
    - "{{ slurm_cluster_name }}/slurm.conf.j2"
    - slurm.conf.j2
    - slurm.conf
  when: slurm_cache_configuration_mode | default(false) and not conf_generated.stat.exists
  run_once: yes
  check_mode: no
  delegate_to: localhost
  tags: configuration

- name: "Configuration (cache mode) | Push configuration"
  copy:
    src: "{{ slurm_tmp_wrkdir }}/slurm.conf"
    dest: "{{slurm_config_dir}}/slurm.conf"
    owner: root
    group: root
    mode: 0644
    backup: true
    #WARNING: this does not seem to always work. While sinfo validates the syntax of the file, some values may not be accepted by the daemon and make it crash.
    #Worse, in that case a subsequent test will fail because sinfo won't be able to contact the controller. Worked around by grepping 'Unable' to return ok status
    #Additionally it is written like this because nodes do not necessarily have sinfo, in that case do not check config.
    #It should have been checked on the controller anyway since it must be the same everywhere.
    validate: "bash -c 'export SLURM_CONF=%s; if command -v /usr/bin/sinfo; then /usr/bin/sinfo 2>&1 |grep Unable || /usr/bin/sinfo ; else true; fi'"
  tags: configuration
  register: slurm_conf
  #config generation of controller can be called from a node
  delegate_to: "{{ configuration_target |default(inventory_hostname) }}"
  #in that case make sure we do not really change it
  check_mode: "{{ ansible_check_mode or configuration_target|default(inventory_hostname)!=inventory_hostname }}"

- name: Configuration | Record configuration result
  set_fact: slurm_configuration_generated="{{ slurm_conf.changed }}"
  tags: configuration
  delegate_to: "{{ configuration_target |default(inventory_hostname) }}"
  delegate_facts: yes

#TODO : trigger service reload if conf has been modified

